'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (options) {
  options = (0, _utils.extend)({}, DEFAULTS, options);

  return function (files, metalsmith, done) {
    if (server.active) {
      server.reload();
      return done();
    }

    var dir = metalsmith.destination();

    var config = (0, _utils.extend)({
      server: { baseDir: dir }
    }, options);

    server.init(config, function (err, bs) {
      if (err) {
        return done(err);
      }

      var urls = bs.getOption('urls');

      log('serving files from %s', dir);
      log('ui url: %s', urls.get('ui'));
      log('local url: %s', urls.get('local'));
      log('external url: %s', urls.get('external'));

      done();
    });
  };
};

var _browserSync = require('browser-sync');

var _browserSync2 = _interopRequireDefault(_browserSync);

var _utils = require('../../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var server = _browserSync2.default.create();
var log = (0, _utils.debug)('metalsmith:serve');

var DEFAULTS = {
  port: 8000,
  open: false,
  logLevel: 'silent'
};